<template>
	<view>
		<nav-bar title="做题记录" class="nav"></nav-bar>
		<!-- <view class="tabs">
			<view class="tab" :class="{ active: index == 1 }" data-index="1" @click="tab(1)">
				全部题库记录
				<u-icon class="icon" :class="index ==1? 'animals':''" name="arrow-down"></u-icon>
			</view>
			<view class="tab" :class="{ active: index == 2 }" data-index="2" @click="tab(2)">
				全部试卷类型
				<u-icon class="icon" :class="index ==2? 'animals':''" name="arrow-down"></u-icon>
			</view>
		</view> -->
		

		<view class="record">
			<view class="item" v-for="(record,index) in recordList" :key="index">
				<view class="note">{{ record.paperName }}</view>
				<view class="title">{{ record.examName }}</view>
				<view class="desc">
					<view>
						<image src="/static/icon/wk_icon2.png"></image>
						<text>{{ $method.timestampToTime(record.updateTime, false) }}</text>
					</view>
					<view>
						<image src="/static/icon/wk_icon2.png"></image>
						<text>总共 {{ record.totalQuestionNum }} 题 做对 {{ record.rightQuestionNum }} 题</text>
					</view>
				</view>
				<view class="btns">
					<view class="btn" v-if="record.status == 1" @click="doRepeat(record.examId, record.goodsId, record.moduleExamId, record.chapterExamId,index,record)">重做</view>
					<view class="btn" @click="questionBankExplain(record)" v-if="record.status == 1">解析</view>
					<view class="btn" @click="questionReport(record)" v-if="record.status == 1">报告</view>
					<view class="btn continue" @click="moreRecord(record,index)" >更多记录</view>
				</view>
			</view>
		</view>

		<view class="modal" :style="{top:modalTop+'px'}" v-if="index == 1">
			<view class="content">
				<scroll-view scroll-y="true" style="height:100%">
					<view class="top" :class="activeIndex === 0 ? 'activesty' : ''" @click="testClick(3)">全部题库记录</view>
					<view class="list">
						<view class="item" :class="activeIndex == listItem.goodsId ? 'activesty' : ''" v-for="(listItem,listIndex) in list" :key="listIndex" @click="testClick(listItem)">
							{{ listItem.goodsName }}
						</view>
					</view>
				</scroll-view>
				
			</view>
			<view class="modal_wrap" @click="index = 0"></view>
		</view>
		
		<view class="modal" :style="{top:modalTop+'px'}" v-if="index == 2">
			<view class="content">
				<scroll-view scroll-y="true" style="height:100%">
					<view class="top" :class="typeIndex === 0 ? 'activesty' : ''" @click="paperClick(3)">全部试卷类型</view>
					<view class="list">
						<view class="item" :class="typeIndex == listItem.paperId ? 'activesty' : ''" v-for="(listItem,listIndex) in list1" :key="listIndex" @click="paperClick(listItem)">{{ listItem.paperName }}</view>
					</view>
				</scroll-view>
			</view>
			<view class="modal_wrap" @click="index = 0"></view>
		</view>
	</view>
</template>

<script>
export default {
	data() {
		return {
			index: 0,
			list: [],
			list1: [],
			recordList: [],
			goodsData: {},
			param: {
				pageNum: 1,
				pageSize: 10
			},
			isRepeat:false,
			total: 0,
			activeIndex: 0,
			typeIndex:0,
			itemIndex:'',
			modalTop:0,
		};
	},
	onLoad(option) {
		// this.listGoodsUserQuestion();
		// this.examaperList();
		this.mockRecordGroupList();
		
		// uni.getSystemInfo({
		// 	success:(e) => {
		// 		let info = uni.createSelectorQuery().select(".nav");
		// 		info.boundingClientRect((navData) => { //data - 各种参数
				
		// 			let info = uni.createSelectorQuery().select(".tabs");
		// 			info.boundingClientRect((tabData) => { //data - 各种参数
		// 				this.modalTop = navData.height + tabData.height
		// 				console.log(navData) // 获取元素宽度
		// 				console.log(tabData) // 获取元素宽度
		// 			}).exec()
		// 		}).exec()
		// 	}
		// })
	},
	onPullDownRefresh() {
		let that = this;
		this.param = {
			pageNum: 1,
			pageSize: 10
		};
		this.mockRecordGroupList();
		setTimeout(function() {
			uni.stopPullDownRefresh();
		}, 500);
	},
	onReachBottom() {
		if (this.recordList.length < this.total) {
			this.param.pageNum++;
			this.mockRecordGroupList();
		}
	},
	onShow() {
		if(this.isRepeat) {
			this.addRecord();
		} else {
			if(this.itemIndex !== '') {
				this.refreshByIndex();
			}
		}
		
	},
	methods: {
		questionBankExplain(record) {
			uni.navigateTo({
				url:'/pages5/examReport/questionBankAllExplain?id=' +
							record.examId +
							'&recordId='+ record.recordId +
							'&eachExamId='+record.eachExamId
				
			})
		},
		questionReport(record) {
			uni.navigateTo({
				url:
				  "/pages5/examReport/index?examId=" +
				  record.examId +
				  "&id=" +
				  record.recordId+
					"&eachExamId="+record.eachExamId+
					"&subscribeId="+record.subscribeId
			})
		},
		/**
		 * 更多记录
		 */
		moreRecord(record) {
			uni.navigateTo({
				url:'./mock_record_list?goodsId='+record.goodsId+'&examId='+record.examId+'&id=' + record.recordId + '&eachExamId='+record.eachExamId
			})
		},
		addRecord() {
			this.$api.examRecordList({
				pageNum: 1,
				pageSize: 1
			}).then(res => {
				this.recordList.unshift(res.data.rows[0])
			});
			this.isRepeat = false;
		},
		refreshByIndex() {
			this.$api.examRecordGroupList({
				pageNum: this.itemIndex+1,
				pageSize: 1
			}).then(res => {
				this.$set(this.recordList,this.itemIndex,res.data.rows[0])
				this.itemIndex = ''
			});
		},
		mockRecordGroupList() {
			if (this.param.pageNum == 1) {
				this.recordList = [];
			}
			this.$api.mockRecordGroupList(this.param).then(res => {
				this.recordList.push.apply(this.recordList, res.data.rows);
				this.total = res.data.total;
			});
		},
		/**
		 * 去做题
		 */
		async doRepeat(id, goodsId, moduleId = 0, chapterId = 0,index,record) {
			uni.navigateTo({
				url:'../examBank/index?examId='+record.examId+'&eachExamId='+record.eachExamId
			})
			return
			// await this.getDetail(goodsId);
			this.itemIndex = '';
			this.isRepeat = true;
			let count = await this.examRecordCount(id,goodsId);
			let answerNum = await this.getExamDetail(id);
			//超过答题次数
			if (answerNum > 0 && count >= answerNum) {
				this.$u.toast('该试卷只能答题' + answerNum + '次!');
				return;
			}

			uni.navigateTo({
				url: '/pages2/bank/questionBank?id=' + id + '&goodsid=' + goodsId + '&moduleId=' + moduleId + '&chapterId=' + chapterId + '&orderGoodsId=' + record.orderGoodsId
			});
		},
		/**
		 * @param {Object} exam_id
		 * 获取试卷可以做的次数
		 */
		getExamDetail(exam_id) {
			return new Promise(resolve => {
				this.$api.getExamDetail(exam_id).then(res => {
					resolve(res.data.data.answerNum);
				});
			});
		},
		/**
		 * 查询试卷历史做题次数
		 */
		examRecordCount(examId,goodsId) {
			return new Promise(resolve => {
				this.$api
					.examRecordCount({
						examId: examId,
						goodsId: goodsId
					})
					.then(res => {
						resolve(res.data.data);
					});
			});
		},

		getDetail(id) {
			return new Promise(resolve => {
				this.$api.goodsDetail(id).then(res => {
					this.goodsData = res.data.data;
					resolve();
				});
			});
		},
		testClick(item) {
			if (item === 3) {
				this.index = 0;
				this.activeIndex = 0;
				this.param.goodsId = '';
				this.param.pageNum = 1;
				this.mockRecordGroupList();
			} else {
				this.index = 0;
				this.activeIndex = item.goodsId;
				this.param.goodsId = item.goodsId;
				this.param.pageNum = 1;
				this.mockRecordGroupList();
			}
		},
		paperClick(item) {
			if (item === 3) {
				this.index = 0;
				this.typeIndex = 0;
				this.param.paperId = '';
				this.param.pageNum = 1;
				this.mockRecordGroupList();
			} else {
				this.index = 0;
				this.typeIndex = item.paperId;
				this.param.paperId = item.paperId;
				this.param.pageNum = 1;
				this.mockRecordGroupList();
			}
		},
		tab(index) {
			console.log(index,this.index)
			if(this.index == index) {
				this.index = 0;
				return;
			}
			this.index = index;
			console.log(this.index);
		},

		examaperList() {
			this.$api.examaperList({}).then(res => {
				this.list1 = res.data.rows;
			});
		},

		listGoodsUserQuestion() {
			this.$api.listGoodsUserQuestion({}).then(res => {
				this.list = res.data.rows;
			});
		}
	}
};
</script>
<style>
page {
	background: #eaeef1;
}
</style>
<style lang="scss" scope>
	.animals{
		transition: all 0.3s;
		transform: rotate(180deg);
	}
.tabs {
	position: fixed;
	left: 0;
	width: 100%;
	display: flex;
	z-index: 10;
	.tab {
		flex: 1;
		height: 80rpx;
		text-align: center;
		line-height: 80rpx;
		background: #ffffff;
		font-size: 32rpx;
		color: #999999;

		&.active {
			color: #333333;
			.icon{
				transform: rotate(180deg);
			}
		}
	}
}

.record {
	margin-top: 20rpx;
	padding: 16rpx 8rpx;
	display: flex;
	flex-wrap: wrap;
	.item {
		margin-bottom: 16rpx;
		width:359rpx;
		background: #ffffff;
		border-radius: 16rpx;
		padding: 65rpx 20rpx 22rpx;
		position: relative;
		overflow: hidden;
		
		&:nth-of-type(2n) {
			margin-left:16rpx;
			
		}

		.note {
			color: #fff;
			position: absolute;
			left: 0;
			top: 0;
			// width: 112rpx;
			padding: 0rpx 10rpx;
			height: 40rpx;
			text-align: center;
			line-height: 40rpx;
			background: linear-gradient(180deg, #4facfe, #007aff);
			border-radius: 16rpx 0px 16rpx 0rpx;
		}

		.title {
			font-size: 32rpx;
			color: #333333;
			font-weight: bold;
		}

		.desc {
			margin-top: 26rpx;
			view {
				margin: 16rpx 0;

				image {
					width: 23rpx;
					height: 24rpx;
				}

				text {
					margin-left: 15rpx;
					font-size: 24rpx;
					color: #999999;
					line-height: 36rpx;
				}
			}
		}

		.btns {
			margin-top: 26rpx;
			display: flex;
			justify-content: space-around;
			flex-wrap: wrap;
			.btn {
				margin:5rpx 0;
				width:150rpx;
				height: 48rpx;
				line-height: 48rpx;
				text-align: center;
				color: #007aff;
				background: #ffffff;
				border: 1rpx solid #007aff;
				border-radius: 16rpx;
				
			}
		}
	}
}

.modal {
	bottom:0;
	z-index: 199999999;
	position: fixed;
	left: 0;
	width: 100%;

	.content {
		height:80%;
		overflow: hidden;
		position: relative;
		z-index: 10;
		background: #fff;
		padding: 8rpx 12rpx 20rpx;
		display: flex;
		flex-wrap: wrap;

		.top {
			margin: 0 auto;
			width: 726rpx;
			height: 80rpx;
			background: #f5f5f5;
			color: #666666;
			border-radius: 16rpx;
			text-align: center;
			line-height: 80rpx;
			font-size: 32rpx;
		}

		.list {
			width:100%;
			margin-top: 16rpx;
			display: flex;
			flex-wrap: wrap;
			justify-content: space-between;

			.item {
				padding: 25rpx 20rpx;
				width: 49%;
				background: #f5f5f5;
				border-radius: 16rpx;
				font-size: 32rpx;
				color: #666666;
				margin: 8rpx 0;
			}
		}
	}

	.modal_wrap {
		position: absolute;
		left: 0;
		width: 100%;
		top: 0;
		height: 100%;
		background: rgba(0, 0, 0, 0.3);
	}
}
.activesty {
	background: #007aff !important;
	color: #fff !important;
}
</style>
